Subject: Re: [PATCH net-next v3 0/5] net: centralize master device offload feature computation

From: Jakub Kicinski <[email-masked]>
Date: Thu, 19 Mar 2026 09:01:05 -0700

On Thu, 19 Mar 2026 10:52:34 +0100 Paolo Abeni wrote:
> On 3/16/26 5:26 AM, Hangbin Liu wrote:
> > Currently, master devices (bonding, bridge, team) manually call
> > netdev_compute_master_upper_features() scattered throughout their port
> > add/remove operations. This approach requires each driver to remember
> > to update features at the right times and leads to code duplication.
> > 
> > The series adds a new ndo_update_offloads callback that is automatically
> > invoked during feature updates when upper/lower device relationships change.
> > This centralizes the feature computation flow and removes the burden
> > from individual drivers.  
> 
> I'm sorry for the late feedback, but I think the driver cleanup and
> simplification is not worthy the core complexity and the new NDO added.

+1 FWIW, I didn't want to be negative but I felt the same way..
We are always one step away from an inf loop propagating the features
it's a delicate space :S